<?php
/**

 Template Name: Perfil
 
 * Plantilla creada per David Galisteo per a visualitzar el perfil d'usuari
 * 
 *
 * @since          Baskerville
 *
 * @package        Acme_Project
 * @subpackage     Baskerville
 */
?>


<?php 
	//Inicio la sesió
	session_start();
	get_header(); 
?>

<script src="https://code.jquery.com/jquery-3.1.1.min.js"></script>
<script src="https://code.jquery.com/ui/1.12.1/jquery-ui.min.js"></script>
<script type="text/javascript">
	$(document).ready(function(){
		//Oculo els divs
		$("#frm_mod_pass").hide();
		$("#spots_fav").hide();
	});
</script>

<div id="map-canvas">
	<?php
	//Recupero dades de sessio
	if(isset($_SESSION['usuari']) and $_SESSION['estat'] == 'Autenticat') {
		
		//Connexió a la base de dades
		require('connexio.php');
		require('funcions.php');
		
		$usuari = $_SESSION['usuari'];
		$consulta = "SELECT * FROM usuaris WHERE email = '$usuari'";
		
		$resultados = $mysqli->query($consulta);

		//Rebo resultats de la BD
		$resultado = $resultados->fetch_array(MYSQLI_ASSOC); ?>
        
        <!-- DIV on es mostra el menú de la pantalla perfil -->
		<div id="menu_perfil">
        	<ul>
            	<li><a href="#" id="lnkDades">Dades Perfil</a></li>
                <li><a href="#" id="lnkSpots">Spots Favorits</a></li>
				<?php //Si l'usuari és administrador, mostro menu d'administració 
				if($resultado['admin'] == 1) { ?>
                	<li><a href="#" id="lnkInsertar">Insertar Nou Spot</a></li>
                    <li><a href="#" id="lnkUsuaris">Gestió Usuaris</a></li>
                <?php } ?>
			</ul>        
        </div>
        
        <!-- DIV on es mostra el contingut de la pantalla perfil -->
        <div id="contingut_perfil">
        	
            <!-- DIV per a les dades del perfil -->
            <div id="dades_perfil">
            	<div id="msg_confirma_pwd"></div>
                <table id="taula_dades_perfil" class="taula">            
                	<tr>
                    	<td>Usuari:</td>
                        <td><?php echo $resultado['nom'];?></td>
                    </tr>
                    <tr>
                        <td>E-mail:</td>
                        <td><?php echo $resultado['email'];?></td>
                    </tr>
                    <tr>
                        <td>Administrador ?</td>
                        <td><?php if ($resultado['admin'] == 1) {
                                  	echo "SI";
                                  } else {
                                    echo "NO";
                                  }?></td>
                    </tr>
                    <tr>
                        <td><input type="button" id="btn_modificar_pwd" class="btn_taula" value="Modificar Password"></td>
                        <td><input type="button" id="del_perfil" class="btn_taula" value="Eliminar Perfil" onclick="confirmar()"></td>
                    </tr>
                </table>
                <div id="frm_mod_pass">
                	<table class="taula">
                    <form method="post" id="form_nou_pwd" name="form_nou_pwd" action="">
                    	<input type="hidden" id="usr_nou_pwd" name="usr_nou_pwd" value="<?php echo $resultado['email'];?>" >
                        <tr>
                        	<td>Nou password:</td>
                            <td><input type="password" id="nou_pwd" name="nou_pwd" /></td>
                        </tr>
                        <tr>
                            <td>Confirma nou password:</td>
                            <td><input type="password" id="nou_pwd_2" name="nou_pwd_2" /></td>
                        </tr>
                        <tr>
                            <td colspan="2"><input type="submit" id="btn_nou_pwd" class="btn_taula" name="btn_nou_pwd" value="Modificar" /></td>
                        </tr>
                    </form>
                    </table>    
                </div>                
            </div>
            <!-- DIV per que l'usuari esculli els spots favorits -->
            <div id="spots_fav">
            	<h1>Spots Favorits</h1>
                <?php
                //Consulta a la BD
                $consultaSpots = "SELECT * FROM spots";
                $resultados = $mysqli->query($consultaSpots); ?>
                <table id="t_spots" class="taula">
                	<tr>
                    <?php
					$filas =0;
                    while ($row=$resultados->fetch_array(MYSQLI_ASSOC)){ 
						if ($filas<4) { ?>
                        	<td>
                                <?php if (4 > 2) { ?>
                            	<input type="checkbox" id="<?php echo $row['id']; ?>" value="<?php echo $row['id']; ?>" /><?php echo $row['etiqueta'];
								} ?>
                            </td>
                            <?php $filas ++; 
						} else { ?>
                           	</tr>
                            <tr>
                            <?php $filas = 0;
						}
                    } ?>
                    </tr>
                    <tr>
                    	<td colspan="4"><input type="button" id="btn_spots" name="btn_spots" value="Actualitzar" /></td>
                    </tr>
                </table>   
            </div>
        </div>
    <?php } else { ?>
    
    	<script>window.location.href = "mapa";</script>
        
	<?php	
	} ?>
</div>

<?php get_footer(); ?>  


<script type="text/javascript">

	//Al clicar el botó "Modificar password" apareix el formulari
	$("#btn_modificar_pwd").on('click', function(e) {
		if($("#btn_modificar_pwd").attr('value') == "Modificar Password"){
			$("#frm_mod_pass").slideDown(500);
			$("#btn_modificar_pwd").val("Cancelar");
		} else {
			$("#frm_mod_pass").hide(500);
			$("#btn_modificar_pwd").val("Modificar Password");
			$("#nou_pwd").val('');
			$("#nou_pwd_2").val('');
			$("#msg_confirma_pwd").hide();
		}
		
		e.preventDefault();
	});
	
	//Al clicar el botó "Modificar" per canviar el password
	$("#form_nou_pwd").on('submit', function(e) {
		//Evito que s'envii per defecte
		e.preventDefault();
	
		//Creo un FormData amb les dades del formulari
		var formData = new FormData(document.getElementById("form_nou_pwd"));
	
		//Crida a la funció AJAX de jQUery
		$.ajax({
			url: 			"wp-content/themes/baskerville/update_pwd.php",
			type: 			"POST",
			dataType:		"HTML",
			data:			formData,
			cache:			false,
			contentType:	false,
			processData:	false
		}).done(function (fet){
			$("#msg_confirma_pwd").html(fet);
			$("#msg_confirma_pwd").slideDown(500);
			$("#btn_modificar_pwd").val("Modificar Password");
			$("#nou_pwd").val('');
			$("#nou_pwd_2").val('');
			$("#form_nou_pwd").hide(); //Porque no va????
		});
	});
	
	//Al clicar el link "Dades Perfil"
	$("#lnkDades").on('click', function(e) {
		$("#spots_fav").hide();
		$("#dades_perfil").show();
	});
	
	//Al clicar el link "Spots Favorits"
	$("#lnkSpots").on('click', function(e) {
		$("#dades_perfil").hide();
		$("#spots_fav").show();
	});
</script>
