<?php
/**

 Template Name: Plantilla GoogleMaps
 
 * Plantilla creada per David Galisteo per a insertar
 * mapa de Google Maps personalitzat amb els "markers" corresponents a cada spot
 *
 * @since          Baskerville
 *
 * @package        Acme_Project
 * @subpackage     Baskerville
 */
?>

<?php 
//Inicio la sesió
session_start();
get_header(); ?>

<div id="map-canvas"></div> <!-- #map-canvas -->

<script type="text/javascript" src="http://maps.googleapis.com/maps/api/js?key=AIzaSyCemhP4EkcILOoQ2qxVbWFrRjY8tqF3tqw"></script>

<?php //Connexió a la base de dades
$mysqli = new mysqli('localhost','user_kitespots','kitespots','db_kitespots');
mysqli_set_charset($mysqli, "utf8");

//Consulta a la base de dades
$resultados = $mysqli->query('SELECT * FROM spots'); 

//Guardo els valors de cada camps en diferents arrays
$i = 1;
while ($row=$resultados->fetch_array(MYSQLI_ASSOC)){
	$ids[$i] = $row['id'];
	$spots[$i] = $row['spot'];
	$etiquetes[$i] = $row['etiqueta'];
	$lats[$i] = $row['latitut'];
	$longs[$i] = $row['longitut'];
	$i++;
} ?>

<script type="text/javascript">
// Script Crear mapa API Google Maps

//COORDENADES DELS SPOTS
<?php for ($i=1;$i<=count($spots);$i++){ ?>
		var <?php echo $spots[$i]; ?>=new google.maps.LatLng(<?php echo $lats[$i]; ?>,<?php echo $longs[$i]; ?>);
		
<?php } ?>

//S'INICIALITZA EL MAPA
function initialize() {
  var mapProp = {
    center:new google.maps.LatLng(41.71796,1.7896505,9),
    zoom:8,
	disableDefaultUI:true,
    mapTypeId:google.maps.MapTypeId.HYBRID
  };
  var map=new google.maps.Map(document.getElementById("map-canvas"),mapProp);
  
  
  /*#################################################################################################################
  ###########################################  MARCADORS DELS SPOTS #################################################
  #################################################################################################################*/
  
  <?php for ($i=1;$i<=count($spots);$i++){ ?>
  			var marker_<?php echo $spots[$i]; ?>=new google.maps.Marker({
  				position:<?php echo $spots[$i]; ?>,
  			});
			marker_<?php echo $spots[$i]; ?>.setMap(map);
			var info<?php echo $spots[$i]; ?> = new google.maps.InfoWindow({
				content:<?php echo '"' . $etiquetes[$i] . '"'; ?>
			});
			google.maps.event.addListener(marker_<?php echo $spots[$i]; ?>, 'mouseover', function() {
				info<?php echo $spots[$i]; ?>.open(map,marker_<?php echo $spots[$i]; ?>);
			});
			google.maps.event.addListener(marker_<?php echo $spots[$i]; ?>, 'mouseout', function() {
				info<?php echo $spots[$i]; ?>.close(map,marker_<?php echo $spots[$i]; ?>);
			});
			google.maps.event.addListener(marker_<?php echo $spots[$i]; ?>, 'click', function() {
				window.location.href = "spot?id=<?php echo $ids[$i]; ?>";
			});
  <?php } ?>
	 
}
google.maps.event.addDomListener(window, 'load', initialize);
</script>

<?php get_footer(); ?>