<?php
/**

 Template Name: Map Favs
 
 * Plantilla creada per David Galisteo per a insertar
 * mapa de Google Maps personalitzat amb els "markers" corresponents als spots favorits de l'usuari registrat
 *
 * @since          Baskerville
 *
 * @package        Acme_Project
 * @subpackage     Baskerville
 */
?>

<?php 
//Inicio la sesió
session_start();
if(isset($_SESSION['usuari']) and $_SESSION['estat'] == 'Autenticat') {
	get_header();
	
	require('connexio.php');
	
	//Busco id de l'usuari
	$usuari = $_SESSION['usuari'];
	$consulta = "SELECT * FROM usuaris WHERE email = '$usuari'";
	$resultats = $mysqli->query($consulta);
	$resultat = $resultats->fetch_array(MYSQLI_ASSOC);
	
	//Consulta a la base de dades spots favorits
	$id_usuari = $resultat['id'];
	$consulta = "SELECT spots.id, spots.etiqueta, spots.latitut, spots.longitut FROM spots, usuari_spots WHERE usuari_spots.id_usuari = '$id_usuari' AND spots.id = usuari_spots.id_spot";
	$resultados = $mysqli->query($consulta); 
	?>

	<script type="text/javascript" src="http://maps.google.com/maps/api/js?sensor=false"></script>
    <script type="text/javascript">
        function initialize() {
          var marcadores = [
            <?php while ($row=$resultados->fetch_array(MYSQLI_ASSOC)){ 
                echo "['".$row['etiqueta']."',".$row['latitut'].", ".$row['longitut'].", ".$row['id']."],";
            }?>
          ];
          var map = new google.maps.Map(document.getElementById('map-canvas'), {
            zoom: 8,
            disableDefaultUI:true,
            center: new google.maps.LatLng(41.71796,1.7896505,9),
            mapTypeId: google.maps.MapTypeId.HYBRID
          });
          var infowindow = new google.maps.InfoWindow();
          var marker, i;
          for (i = 0; i < marcadores.length; i++) {  
            marker = new google.maps.Marker({
              position: new google.maps.LatLng(marcadores[i][1], marcadores[i][2]),
              map: map
            });
            google.maps.event.addListener(marker, 'mouseover', (function(marker, i) {
              return function() {
                infowindow.setContent(marcadores[i][0]);
                infowindow.open(map, marker);
              }
            })(marker, i));
            google.maps.event.addListener(marker, 'mouseout', (function(marker, i) {
              return function() {
                infowindow.setContent(marcadores[i][0]);
                infowindow.close(map, marker);
              }
            })(marker, i));
            google.maps.event.addListener(marker, 'click', (function(marker, i) {
              return function() {
                window.location.href = "spot?id="+marcadores[i][3];
              }
            })(marker, i));
          }
        }
        google.maps.event.addDomListener(window, 'load', initialize);
    </script>
    <div id="map-canvas"></div> <!-- #map-canvas -->
    
    
    <?php get_footer();
} else { ?>
	<script>window.location.href = "mapa";</script>
<?php } ?>
	